/*  This application draws a blue circle with a
 * red border, as well as a yellow triangle inside it.
 */


#include "mainwindow.h"
#include <QApplication>

#include "menubar.h"

int main(int argc, char *argv[])
{
    QApplication a(argc, argv);
    MainWindow w;

    w.resize(420, 450);
    w.setMinimumSize(220, 250);

    //  QPixmap objects are being allocated on the stack, even though
    //  the library functions are programmed intelligently enough
    //  not to do so.

    //  At 800x800 pixels, 640000 pixels are being put on the stack.
    //  That's 1920000 bytes just for pixels.
    //  On most systems I'm familiar with, the stack limit is
    //  8192KiBi (in other words, ~4x as high).
    //  Therefore, I think that a limit of 800x800 on the
    //  QPixmap is reasonable.

    //  +20, +50 for the window features.

    w.setMaximumSize(820, 850);

    SimpleMenu s(&w);

    w.show();

    return a.exec();
}
