/*  This window object draws a blue circle with a
 * red border, as well as a yellow triangle inside it.
 */


#include "mainwindow.h"

MainWindow::MainWindow(QWidget *parent)
    : QMainWindow(parent)
{
    mVBox = NULL;

    center_widget = new QWidget;
    mVBox = new QVBoxLayout(center_widget);
    i_label = new QLabel(this);
    i_label->setPixmap(QPixmap(400, 400));  // !
    mVBox->addWidget(i_label, Qt::AlignCenter);

    setCentralWidget(center_widget);
}

MainWindow::~MainWindow()
{

}


void MainWindow::resetQ()
{
    if (windowState() & (Qt::WindowMinimized | Qt::WindowMaximized)) {
        setWindowState((windowState() & ~Qt::WindowMinimized & ~Qt::WindowMaximized) | Qt::WindowActive);
        QTimer::singleShot(1000, this, &MainWindow::resetQ);
        return;
    }
    resize(420,450);
}

void MainWindow::fileSave()
{
    QFile file("Saved_Pattern.png");
    file.open(QIODevice::WriteOnly);
    i_label->pixmap()->save(&file, "PNG");
    file.close();
}


void MainWindow::resizeEvent(QResizeEvent *event)
{
    QMainWindow::resizeEvent(event);

    QBrush brush1(Qt::blue);
    brush1.setStyle(Qt::CrossPattern);
    QPen pen1(Qt::red);
    pen1.setWidth(4);
    pen1.setStyle(Qt::DashLine);

    QBrush brush2(Qt::yellow);
    brush2.setStyle(Qt::Dense5Pattern);
    QPen pen2(Qt::yellow);
    pen2.setWidth(2);
    pen2.setCapStyle(Qt::RoundCap);

    qreal window_width = size().width() - 20;
    qreal window_height = size().height() - 50;

    QPixmap temp_pixmap(window_width, window_height);  // !
    temp_pixmap.fill(Qt::gray);

    QPoint top_left(window_width / 4, window_height / 4);
    QPoint bottom_right(window_width * 3 / 4, window_height * 3 / 4);

    QPoint vertices[3] = {
        QPoint(window_width * 2 / 5, window_height * 9 / 16),
        QPoint(window_width * 3 / 5, window_height * 9 / 16),
        QPoint(window_width / 2, window_height * 3 / 8)
    };

    QRect box(top_left, bottom_right);

    QPainter painter;

    painter.begin(&temp_pixmap);
    painter.setPen(pen1);
    painter.setBrush(brush1);

    painter.setRenderHint(QPainter::Antialiasing);

    painter.drawEllipse(box);

    painter.setBrush(brush2);
    painter.setPen(pen2);

    painter.drawConvexPolygon(vertices, 3);

    painter.end();

    i_label->setPixmap(temp_pixmap);
    i_label->setAlignment(Qt::AlignCenter);

}
